Bug 1279112 - Review Request: kiss-fft - Fast Fourier Transform library
Review Request: kiss-fft - Fast Fourier Transform library
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Zbigniew Jędrzejewski-Szmek
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1261681
  Show dependency treegraph
 
Reported: 2015-11-07 17:59 EST by František Dvořák
Modified: 2016-12-03 01:49 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-12-02 16:24:49 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
zbyszek: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description František Dvořák 2015-11-07 17:59:45 EST
Spec URL: http://scientific.zcu.cz/fedora/kissfft-130-1/kissfft.spec
SRPM URL: http://scientific.zcu.cz/fedora/kissfft-130-1/kissfft-130-1.fc24.src.rpm
Description: A Fast Fourier Transform based up on the principle, "Keep It Simple, Stupid". Kiss FFT is a very small, reasonably efficient, mixed radix FFT library that can use either fixed or floating point data types.
Fedora Account System Username: valtri

* koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=11746945
* used in new version of QM Vamp plugins: https://copr-fe.cloud.fedoraproject.org/coprs/valtri/vamp-plugins
Comment 1 Dmitry Mikhirev 2015-12-24 16:05:11 EST
An informal review.

* The correct version number should be 1.3.0, not 130 (according to folder names at http://sourceforge.net/projects/kissfft/files/kissfft/).
* As the complete library name is "Kiss FFT" and upstream source archive is named kiss_fft, probably the more correct name for package should be delimited, kiss-fft.
* Building only static libraries seems reasonable.

rpmlint output:

Checking: kissfft-devel-130-1.fc23.x86_64.rpm
          kissfft-130-1.fc23.src.rpm
kissfft-devel.x86_64: W: spelling-error %description -l en_US radix -> radii, radio, rad ix
kissfft.src: W: spelling-error %description -l en_US radix -> radii, radio, rad ix
2 packages and 0 specfiles checked; 0 errors, 2 warnings.

Everything is OK.
Comment 2 Antonio Trande 2015-12-25 12:43:15 EST
If you just need to package static libs and header files, I think it's better naming this package 'kissfft-static' and providing header files separately in 'kissfft-devel'.

- These lines are redundant:

>%dir %{_includedir}/%{name}/
>%{_includedir}/%{name}/kfc.h
>%{_includedir}/%{name}/kiss_fft.h
>%{_includedir}/%{name}/kiss_fftnd.h
>%{_includedir}/%{name}/kiss_fftndr.h
>%{_includedir}/%{name}/kissfft.hh
>%{_includedir}/%{name}/kiss_fftr.h

You may use only:

%{_includedir}/%{name}/

- Why 'numpy' and 'Python2' among BR packages?
Comment 3 František Dvořák 2015-12-26 20:52:20 EST
Thank you for the comments and checks.



(In reply to Dmitry Mikhirev from comment #1)
> An informal review.
> 
> * The correct version number should be 1.3.0, not 130 (according to folder
> names at http://sourceforge.net/projects/kissfft/files/kissfft/).

Good catch, it is also in the ChangeLog this way.

> * As the complete library name is "Kiss FFT" and upstream source archive is
> named kiss_fft, probably the more correct name for package should be
> delimited, kiss-fft.

OK. I weren't sure about the name:
* SF project name and header path are "kissfft"
* README is not consistent
* archive is kiss_fft

The "kiss-fft" will be better.

> * Building only static libraries seems reasonable.
> 

Yes, it looks like the kissfft library is supposed to be bundled and compiled in the project using it, and there is no versioning of the library interface.

> 
> Everything is OK.



(In reply to Antonio Trande from comment #2)
> If you just need to package static libs and header files, I think it's
> better naming this package 'kissfft-static' and providing header files
> separately in 'kissfft-devel'.
> 

With 'kissfft-devel' and 'kissfft-static' one could expect source package 'kissfft'. I would prefer to not changing it (only renamed to 'kiss-fft' as Dmitry have suggested). It would be also ready for possible transition to the shared libraries.

But it is good point. I agree I don't have strong arguments here (and it is probably more about "packaging style").

> - These lines are redundant:
> 
> >%dir %{_includedir}/%{name}/
> >%{_includedir}/%{name}/kfc.h
> >%{_includedir}/%{name}/kiss_fft.h
> >%{_includedir}/%{name}/kiss_fftnd.h
> >%{_includedir}/%{name}/kiss_fftndr.h
> >%{_includedir}/%{name}/kissfft.hh
> >%{_includedir}/%{name}/kiss_fftr.h
> 
> You may use only:
> 
> %{_includedir}/%{name}/
> 

OK, more simple spec file can be better. Updated.

> - Why 'numpy' and 'Python2' among BR packages?

Python is used in the tests in %check, with the mathematical operations from numpy.



New version:

Spec URL: http://scientific.zcu.cz/fedora/kiss-fft-1.3.0-1/kiss-fft.spec
SRPM URL: http://scientific.zcu.cz/fedora/kiss-fft-1.3.0-1/kiss-fft-1.3.0-1.fc24.src.rpm
Comment 4 Christopher Meng 2015-12-27 06:54:53 EST
Thanks for packaging this, I need this package for another software.
Comment 5 Christopher Meng 2015-12-27 06:58:12 EST
You can %global srcver underneath Version tag with sed substitution(s/\.//g)
Comment 6 Upstream Release Monitoring 2015-12-27 12:54:18 EST
valtri's scratch build of kiss-fft-1.3.0-1.fc23.src.rpm for f24 completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12327544
Comment 7 František Dvořák 2015-12-27 13:08:07 EST
(In reply to Christopher Meng from comment #4)
> Thanks for packaging this, I need this package for another software.

So it's good there are all data types in the package :-) (for qm-dsp only float is needed). Which datatype is used in the software?

There are also needed some build flags with kissfft: -Dkiss_fft_scalar=$(DATATYPE) or -DFIXED_POINT=32 (16). I should probably add  pkgconfig files for it...

(In reply to Christopher Meng from comment #5)
> You can %global srcver underneath Version tag with sed substitution(s/\.//g)

OK, I've used this (to keep all macros on the top):

%global version 1.3.0
%global srcname kiss_fft
%global srcver %(echo %{version} | sed -e 's/\\.//g')


New version:
Spec URL: http://scientific.zcu.cz/fedora/kiss-fft-1.3.0-1/kiss-fft.spec
SRPM URL: http://scientific.zcu.cz/fedora/kiss-fft-1.3.0-1/kiss-fft-1.3.0-1.fc24.src.rpm
Comment 8 Zbigniew Jędrzejewski-Szmek 2016-11-13 11:51:23 EST
František, are you still interested in packaging this? If yes, I'll review.
Comment 9 František Dvořák 2016-11-13 19:19:43 EST
Yes, I'm still interested. Thanks!
Comment 10 Zbigniew Jędrzejewski-Szmek 2016-11-14 08:13:59 EST
Please remove the definition of %version: just put the version in Version, rpm defines the macro %version automatically.

All %descriptions have an empty line at the beggining, it should be removed.

I'd change:
for type in float double int16 int32; do
    mkdir build_${type}
    pushd build_${type}
    CFLAGS="%{optflags}" LDFLAGS="%{?__global_ldflags}" \
    DATATYPE=${type} \
        make %{?_smp_mflags} -f %{SOURCE1} libdir=%{_libdir} srcdir=..
    popd
done
→
for type in float double int16 int32; do
    mkdir build_${type}
    %make_build -f %{SOURCE1} libdir=%{_libdir} srcdir=.. \
        CFLAGS="%{optflags}" LDFLAGS="%{?__global_ldflags}" \
        DATATYPE=${type}
done
(only because it's simpler...)

%{!?_licensedir:%global license %doc}
is not necessary, %license is now defined in all Fedora and EPEL versions.

Please add a comment that fftw is only used for benchmarking during build (FFTW is GPLv2).

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (3 clause)", "Public domain BSD (3 clause)", "Unknown or
     generated". 26 files have unknown license. Detailed output of
     licensecheck in /var/tmp/1279112-kiss-fft/licensecheck.txt
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: Static libraries in -static or -devel subpackage, providing -devel if
     present.
     Note: Package has .a files: kiss-fft-devel.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
     (The benchmarks and tests pass, I didn't perform any tests on my own.)
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.

Rpmlint
-------
Checking: kiss-fft-devel-1.3.0-1.fc26.x86_64.rpm
          kiss-fft-1.3.0-1.fc26.src.rpm
kiss-fft-devel.x86_64: W: spelling-error %description -l en_US radix -> radii, radio, rad ix
"radix" is correct, I believe.

Requires
--------
kiss-fft-devel (rpmlib, GLIBC filtered):

Provides
--------
kiss-fft-devel:
    kiss-fft-devel
    kiss-fft-devel(x86-64)
    kiss-fft-static

http://koji.fedoraproject.org/koji/taskinfo?taskID=16448346

Package is APPROVED, please fix various cosmetic issues listed at the top when uploading.
Comment 11 František Dvořák 2016-11-14 16:24:12 EST
(In reply to Zbigniew Jędrzejewski-Szmek from comment #10)
> Please remove the definition of %version: just put the version in Version,
> rpm defines the macro %version automatically.
> 

Right, it will be better to not override %{version} macro. Updated.

> All %descriptions have an empty line at the beggining, it should be removed.
> 

Nice catch, updated.

> I'd change:
> for type in float double int16 int32; do
>     mkdir build_${type}
>     pushd build_${type}
>     CFLAGS="%{optflags}" LDFLAGS="%{?__global_ldflags}" \
>     DATATYPE=${type} \
>         make %{?_smp_mflags} -f %{SOURCE1} libdir=%{_libdir} srcdir=..
>     popd
> done
> →
> for type in float double int16 int32; do
>     mkdir build_${type}
>     %make_build -f %{SOURCE1} libdir=%{_libdir} srcdir=.. \
>         CFLAGS="%{optflags}" LDFLAGS="%{?__global_ldflags}" \
>         DATATYPE=${type}
> done
> (only because it's simpler...)
> 

There is difference between:

  make CFLAGS=...

and:

  CFLAGS=... make

I would rather not change it. It's only cosmetic hint anyway, right?

> %{!?_licensedir:%global license %doc}
> is not necessary, %license is now defined in all Fedora and EPEL versions.
>

OK, removed.
 
> Please add a comment that fftw is only used for benchmarking during build
> (FFTW is GPLv2).
> 

Comment added.

Thanks for the review!
Comment 12 Gwyn Ciesla 2016-11-14 16:27:02 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/kiss-fft
Comment 13 Zbigniew Jędrzejewski-Szmek 2016-11-14 18:31:01 EST
(In reply to František Dvořák from comment #11)
> There is difference between:
>   make CFLAGS=...
> and:
>   CFLAGS=... make
> 
> I would rather not change it. It's only cosmetic hint anyway, right?

Yes, both should work.
Comment 14 Fedora Update System 2016-11-15 08:15:09 EST
qm-vamp-plugins-1.7.1-1.el7 qm-dsp-1.7.1-1.el7 kiss-fft-1.3.0-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-078a10dcfc
Comment 15 Fedora Update System 2016-11-15 08:15:31 EST
qm-vamp-plugins-1.7.1-1.el6 qm-dsp-1.7.1-1.el6 kiss-fft-1.3.0-1.el6 has been submitted as an update to Fedora EPEL 6. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-a7e9c92ffb
Comment 16 Fedora Update System 2016-11-15 08:15:43 EST
qm-vamp-plugins-1.7.1-1.fc25 qm-dsp-1.7.1-1.fc25 kiss-fft-1.3.0-1.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2016-e69dcc5d0b
Comment 17 Fedora Update System 2016-11-15 09:24:04 EST
kiss-fft-1.3.0-1.el7, qm-dsp-1.7.1-1.el7, qm-vamp-plugins-1.7.1-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-078a10dcfc
Comment 18 Fedora Update System 2016-11-15 12:18:28 EST
kiss-fft-1.3.0-1.el6, qm-dsp-1.7.1-1.el6, qm-vamp-plugins-1.7.1-1.el6 has been pushed to the Fedora EPEL 6 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-a7e9c92ffb
Comment 19 Fedora Update System 2016-11-16 15:24:15 EST
kiss-fft-1.3.0-1.fc25, qm-dsp-1.7.1-1.fc25, qm-vamp-plugins-1.7.1-1.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-e69dcc5d0b
Comment 20 Fedora Update System 2016-12-02 16:24:49 EST
kiss-fft-1.3.0-1.fc25, qm-dsp-1.7.1-1.fc25, qm-vamp-plugins-1.7.1-1.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.
Comment 21 Fedora Update System 2016-12-03 01:47:15 EST
kiss-fft-1.3.0-1.el6, qm-dsp-1.7.1-1.el6, qm-vamp-plugins-1.7.1-1.el6 has been pushed to the Fedora EPEL 6 stable repository. If problems still persist, please make note of it in this bug report.
Comment 22 Fedora Update System 2016-12-03 01:49:39 EST
kiss-fft-1.3.0-1.el7, qm-dsp-1.7.1-1.el7, qm-vamp-plugins-1.7.1-1.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.